import java.util.List;

/**
 * Menue is a class to built a menue
 *
 * @author: Madeleine Vigier
 * @version: 1.0
 */
public class Menue {
    String date;
    String dish;
    String sideDish;
    String typ;
    List<String> ingredients;


    /**
     * constructor
     *
     * @param date        date of meal
     * @param dish        meal
     * @param sideDish    side dish
     * @param typ         vegan, vegetarian or meat
     * @param ingredients list of ingredients
     */
    public Menue(String date, String dish, String sideDish, String typ, List<String> ingredients) {
        this.date = date;
        this.dish = dish;
        this.sideDish = sideDish;
        this.typ = typ;
        this.ingredients = ingredients;
    }

    /**
     * The method get Date() gets the date
     *
     * @return date
     * @author Madeleine Vigier
     * @version 1.0
     */
    public String getDate() {
        return date;
    }

    /**
     * The method getTyp() gets the typ of the meal
     *
     * @return typ e.g. Vegan
     * @author Madeleine Vigier
     * @version 1.0
     */
    public String getTyp() {
        if (typ.contains("DessertV") || typ.contains("Dessert")) {
            return "";
        } else {

            return typ;
        }
    }


    /**
     * The method toString() returns a String representation of an object
     *
     * @return a String with dish, sideDish, list of ingredients and the typ of the menue
     * @author Madeleine Vigier
     * @version 1.0
     */
    @Override
    public String toString() {
        return dish + "\n" + sideDish
                + "\n" + ingredients.toString().replace("[", "").replace("]", "") + "\n" + getTyp() + "\n";
    }
}

